// standard exceptions                                           -*- C++ -*-
// $Id: exceptions.h,v 1.1 2003/10/19 17:17:27 roger Exp $
//
// Copyright (C) 2003  Roger Leigh <rleigh@debian.org>
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef PQXX_OBJECT_EXCEPTIONS_H
#define PQXX_OBJECT_EXCEPTIONS_H

#include <stdexcept>

namespace pqxxobject
{
  /**
   * A backend database error.
   * This exception is thown by all database-interacting classes in
   * the case that the backend database caused libpqxx to throw an
   * exception, or in the case of a runtime error in the database
   * logic.
   */
  class DatabaseError : public std::runtime_error
  {
  public:
    /**
     * Throw a database error.
     * @param what_arg a description of the error.
     */
    DatabaseError (const std::string& what_arg): std::runtime_error(what_arg) { }
  };

}; // namespace pqxxobject

#endif // PQXX_OBJECT_EXCEPTIONS_H
