// database row template class                                       -*- C++ -*-
// $Id: row.h,v 1.4 2004/01/18 00:11:15 roger Exp $
//
// Copyright (C) 2003  Roger Leigh <rleigh@debian.org>
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef PQXX_OBJECT_ROW_H
#define PQXX_OBJECT_ROW_H

#include <memory>

#include <pqxx-object/row_base.h>
#include <pqxx-object/rowconvert.h>

namespace pqxxobject
{
  /**
   * Database row template class.
   */
  template<typename Row>
  class row : public row_base
  {
  public:
    typedef std::auto_ptr<Row> row_ptr;

    row():
      row_base()
    {}

    row(row_state status,
	bool modified=false):
      row_base(status, modified)
    {}

    virtual ~row()
    {}


    /**
     * Create a "row object" from a row of a result set.
     * This method converts a row of a result set into an object.
     * @param row an iterator pointing to a row of a result set.
     * @param tran the transaction which was used to return row.  This
     * is used for recursive initialisation of objects e.g. when
     * contained or derived-from objects must also be initialised.
     * @returns a pointer to a row object, or NULL if the conversion
     * failed.
     */
//     static row_ptr create(pqxx::result::const_iterator row,
// 			  transaction& tran);


  }; // class row

}; // namespace pqxxobject

#endif // PQXX_OBJECT_ROW_H
